<template>
  <Transition name="fade">
    <div class="modal-wrapper" ref="wrapper" v-if="windowIsOPen">
      <div class="modal-window" :style="{ width: modalWidth }">
        <div class="modal-header">
          <h4>{{ modalHeader }}</h4>
          <button class="modal-close" @click="closeModalWindow">
            <nuxt-icon name="IconClose" filled class="icon"/>
          </button>
        </div>
        <div class="modal-body">
          <slot name="content"></slot>
        </div>
        <div class="modal-footer">
          <slot name="footer"></slot>
        </div>
      </div>
    </div>
  </Transition>
</template>

<script setup>
const props = defineProps({
  windowIsOPen: Boolean,
  closeIsImposible: Boolean,
  modalHeader: String,
  modalWidth: String,
});

const emit = defineEmits(["update:windowIsOPen"]);
const closeModalWindow = () => {
  if (!props.closeIsImposible) emit("update:windowIsOPen", false);
  else return;
};
const wrapper = ref(null);
onMounted(() => {
  document.addEventListener("click", (item) => {
    if (item.target === wrapper.value) closeModalWindow();
  });
});
</script>

<style lang="sass" scoped>
@import '../assets/styles/_variables'
.modal
    &-wrapper
        background-color: rgba(0, 0, 0, 0.3)
        position: fixed
        top: 0
        left: 0
        bottom: 0
        right: 0
        height: 100%
        width: 100%
        z-index: 11
    &-window
        width: 40vw
        min-height: 60vh
        height: fit-content
        z-index: 111
        background-color: $white
        margin: 3vh auto
        display: flex
        flex-direction: column
    &-header
        display: flex
        justify-content: flex-end
        padding: .5rem
        gap: 30%
    &-close
        cursor: pointer
        background: transparent
        border: none
        width: 2rem
        &:hover
            .icon
                transition: .2s ease-in
                fill: #6D6E6F

    &-body
        padding: 1rem
        flex: 1 0 auto
    &-footer
        margin-bottom: 1rem
        padding: .5rem
        flex: 0 0 auto
        display: flex
        justify-content: center
.icon
    fill: #C9C9C9
.fade
    &-enter-active, &-leave-active
        transition: opacity .3s
    &-enter, &-leave-to
        opacity: 0
</style>
